Bug 544375 - cobbler4j, url flag in ks is not getting set, kickstart hangs/fails
cobbler4j, url flag in ks is not getting set, kickstart hangs/fails
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: cobbler (Show other bugs)
rawhide
All Linux
high Severity medium
: ---
: ---
Assigned To: Devan Goodwin
wes hayutin
na
:
Depends On:
Blocks: RHQ_Cobbler/RHQ_Cobbler4j
  Show dependency treegraph
 
Reported: 2009-12-04 13:43 EST by wes hayutin
Modified: 2010-01-18 08:28 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-01-05 11:03:13 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
url set to $tree (551.46 KB, image/png)
2009-12-04 13:43 EST, wes hayutin
no flags Details

  None (edit)
Description wes hayutin 2009-12-04 13:43:40 EST
Created attachment 376163 [details]
url set to $tree

Description of problem:

cobbler sha 33e4e021ab1bd49a8ecbf27f4185e128f90a6540

running a ks created by cobbler4j

# Use network installation
url --url=$tree
# If any cobbler repo definitions were referenced in the kickstart profile, include them here.


The kickstart fails do the url flag not being set.

[root@whayutin kickstarts]# cobbler profile report --name=RHEL5-i386-profile
Name                           : RHEL5-i386-profile
Comment                        : 
DHCP Tag                       : default
Distribution                   : RHEL5-i386
Enable PXE Menu?               : 1
Kernel Options                 : {}
Kernel Options (Post Install)  : {}
Kickstart                      : /var/lib/cobbler/kickstarts/sample.ks
Kickstart Metadata             : {}
Management Classes             : []
Name Servers                   : []
Name Servers Search Path       : []
Owners                         : ['admin']
                               : 
Red Hat Management Key         : <<inherit>>
Red Hat Management Server      : <<inherit>>
Repos                          : []
Server Override                : <<inherit>>
Template Files                 : {}
Virt Auto Boot                 : 1
Virt Bridge                    : xenbr0
Virt CPUs                      : 1
Virt File Size(GB)             : 5
Virt Path                      : 
Virt RAM (MB)                  : 512
Virt Type                      : xenpv

[root@whayutin kickstarts]# cobbler distro report --name=RHEL5-i386
Name                           : RHEL5-i386
Architecture                   : i386
Breed                          : redhat
Comment                        : 
Initrd                         : /mnt/engarchive/released/RHEL-5-Server/U4/i386/os/images/xen/initrd.img
Kernel                         : /mnt/engarchive/released/RHEL-5-Server/U4/i386/os/images/xen/vmlinuz
Kernel Options                 : {}
Kernel Options (Post Install)  : {}
Kickstart Metadata             : {}
Management Classes             : []
OS Version                     : rhel5
Owners                         : ['admin']
Red Hat Management Key         : <<inherit>>
Red Hat Management Server      : <<inherit>>
Template Files                 : {}


See screenshot
Comment 1 Trever Fischer 2009-12-21 17:39:53 EST
I have the same problem here, with trying to boot rescue-f12-x86_64, imported via cobbler import from an rsync download of F12. Here's what dumpvars says about it:

{'allow_duplicate_hostnames': 0,                                                                                            
 'allow_duplicate_ips': 0,                                                                                                  
 'allow_duplicate_macs': 0,                                                                                                 
 'anamon_enabled': 0,                                                                                                       
 'arch': 'x86_64',                                                                                                          
 'bind_bin': '/usr/sbin/named',                                                                                             
 'breed': 'redhat',                                                                                                         
 'build_reporting_email': ['root@localhost'],                                                                               
 'build_reporting_enabled': 0,                                                                                              
 'build_reporting_sender': '',                                                                                              
 'build_reporting_smtp_server': 'localhost',                                                                                
 'build_reporting_subject': '',                                                                                             
 'build_reporting_to_address': '',                                                                                          
 'cheetah_import_whitelist': ['random', 're', 'time'],                                                                      
 'cobbler_master': '',                                                                                                      
 'comment': '',                                                                                                             
 'ctime': 1261027370.095103,                                                                                                
 'default_kickstart': '/var/lib/cobbler/kickstarts/default.ks',                                                             
 'default_name_servers': [],                                                                                                
 'default_name_servers_search': [],                                                                                         
 'default_ownership': ['admin'],                                                                                            
 'default_password_crypted': '$1$mF86/UHC$WvcIcX2t6crBz2onWxyac.',                                                          
 'default_virt_bridge': 'xenbr0',                                                                                           
 'default_virt_file_size': 5,                                                                                               
 'default_virt_ram': 512,                                                                                                   
 'default_virt_type': 'xenpv',                                                                                              
 'depth': 1,                                                                                                                
 'dhcp_tag': 'default',                                                                                                     
 'dhcpd_bin': '/usr/sbin/dhcpd',                                                                                            
 'dhcpd_conf': '/etc/dhcpd.conf',                                                                                           
 'distro': 'f12-x86_64',                                                                                                    
 'distro_name': 'f12-x86_64',                                                                                               
 'dnsmasq_bin': '/usr/sbin/dnsmasq',                                                                                        
 'dnsmasq_conf': '/etc/dnsmasq.conf',                                                                                       
 'enable_menu': True,                                                                                                       
 'func_auto_setup': 0,                                                                                                      
 'func_master': 'overlord.example.org',                                                                                     
 'http_port': 80,                                                                                                           
 'http_server': 'jupiter.milkyway.wm161.net',                                                                               
 'httpd_bin': '/usr/sbin/httpd',                                                                                            
 'initrd': '/var/www/cobbler/ks_mirror/f12-x86_64/images/pxeboot/initrd.img',                                               
 'isc_set_host_name': 0,                                                                                                    
 'kerberos_realm': 'EXAMPLE.COM',                                                                                           
 'kernel': '/var/www/cobbler/ks_mirror/f12-x86_64/images/pxeboot/vmlinuz',                                                  
 'kernel_options': {'ksdevice': 'bootif',                                                                                   
                    'kssendmac': None,                                                                                      
                    'lang': ' ',                                                                                            
                    'rescue': None,                                                                                         
                    'text': None},                                                                                          
 'kernel_options_post': '',                                                                                                 
 'kernel_options_s390x': {'RUNKS': 1,                                                                                       
                          'ip': False,                                                                                      
                          'ramdisk_size': 40000,                                                                            
                          'ro': None,                                                                                       
                          'root': '/dev/ram0',                                                                              
                          'vnc': None},                                                                                     
 'kickstart': '/var/lib/cobbler/kickstarts/pxerescue.ks',                                                                   
 'ks_meta': {},                                                                                                             
 'ldap_anonymous_bind': 1,                                                                                                  
 'ldap_base_dn': 'DC=wm161,DC=net',                                                                                         
 'ldap_port': 389,                                                                                                          
 'ldap_search_bind_dn': '',                                                                                                 
 'ldap_search_passwd': '',                                                                                                  
 'ldap_search_prefix': 'uid=',                                                                                              
 'ldap_server': 'localhost',                                                                                                
 'ldap_tls': 1,                                                                                                             
 'manage_dhcp': 0,                                                                                                          
 'manage_dns': 0,                                                                                                           
 'manage_forward_zones': [],                                                                                                
 'manage_reverse_zones': [],                                                                                                
 'manage_xinetd': 0,                                                                                                        
 'mgmt_classes': [],                                                                                                        
 'mgmt_parameters': {'from_cobbler': 1},                                                                                    
 'mtime': 1261349982.746103,                                                                                                
 'name': 'rescue-f12-x86_64',                                                                                               
 'name_servers': [],                                                                                                        
 'name_servers_search': [],                                                                                                 
 'named_conf': '/etc/named.conf',                                                                                           
 'next_server': '10.0.0.2',                                                                                                 
 'omapi_enabled': 0,                                                                                                        
 'omapi_port': 647,                                                                                                         
 'omshell_bin': '/usr/bin/omshell',                                                                                         
 'os_version': '',                                                                                                          
 'owners': ['admin'],                                                                                                       
 'parent': '',                                                                                                              
 'power_management_default_type': 'ipmitool',                                                                               
 'power_template_dir': '/etc/cobbler/power',                                                                                
 'profile_name': 'rescue-f12-x86_64',                                                                                       
 'pxe_just_once': 0,                                                                                                        
 'pxe_template_dir': '/etc/cobbler/pxe',                                                                                    
 'random_id': 'z5KP',                                                                                                       
 'redhat_management_key': '',                                                                                               
 'redhat_management_permissive': 0,                                                                                         
 'redhat_management_server': 'xmlrpc.rhn.redhat.com',                                                                       
 'redhat_management_type': 'off',                                                                                           
 'register_new_installs': 0,                                                                                                
 'repos': [],                                                                                                               
 'restart_dhcp': 1,                                                                                                         
 'restart_dns': 1,                                                                                                          
 'restart_xinetd': 1,                                                                                                       
 'run_install_triggers': 1,                                                                                                 
 'scm_track_enabled': 0,                                                                                                    
 'scm_track_mode': 'git',                                                                                                   
 'server': 'jupiter.milkyway.wm161.net',                                                                                    
 'snippetsdir': '/var/lib/cobbler/snippets',                                                                                
 'source_repos': [],                                                                                                        
 'template_files': {},                                                                                                      
 'tftpd_bin': '/usr/sbin/in.tftpd',                                                                                         
 'tftpd_conf': '/etc/xinetd.d/tftp',                                                                                        
 'tftpd_rules': '/etc/tftpd.rules',                                                                                         
 'tree_build_time': 0.0,                                                                                                    
 'uid': 'MTI2MTAyNzM3MC4xOTIwOTY5Ni40MDgyOA',                                                                               
 'virt_bridge': 'xenbr0',
 'virt_cpus': 1,
 'virt_file_size': 5,
 'virt_path': '',
 'virt_ram': 512,
 'virt_type': 'qemu',
 'vsftpd_bin': '/usr/sbin/vsftpd',
 'webdir': '/var/www/cobbler',
 'xmlrpc_port': 25151,
 'yum_post_install_mirror': 1,
 'yumdownloader_flags': '--resolve',
 'yumreposync_flags': '-l'}
Comment 2 Devan Goodwin 2010-01-05 11:03:13 EST
If you run cobbler distro report --name="distroname" for whatever profile you're getting into trouble with, you'll likely see an empty Kickstart Metadata hash. It *should* look something like this:

Name                           : rhel-5.3-i386
Architecture                   : i386
Breed                          : redhat
Comment                        : rhel5.3
Initrd                         : /var/www/cobbler/ks_mirror/rhel-5.3/images/pxeboot/initrd.img
Kernel                         : /var/www/cobbler/ks_mirror/rhel-5.3/images/pxeboot/vmlinuz
Kernel Options                 : {}
Kernel Options (Post Install)  : {}
Kickstart Metadata             : {'tree': 'http://@@http_server@@/cblr/links/rhel-5.3-i386'}
Management Classes             : []
OS Version                     : rhel5
Owners                         : ['admin']
Red Hat Management Key         : <<inherit>>
Red Hat Management Server      : <<inherit>>
Template Files                 : {}

In Wes' case this is the result of a missing call to Distro.setKsMeta() in the Java code he used to create the distribution. Going to close the bug as I'm pretty certain we found the problem but feel free to re-open it that still doesn't work Wes.

As for your case Trevor I'm not sure what's going on, but checkout your distro's report and see what's in there for the tree. Feel free to post back here even if it's a separate issue and we'll see if we can sort it out.
Comment 3 Trever Fischer 2010-01-06 13:00:32 EST
The tree is empty. Actually, the value for ks metadata is empty. Its just '{}':

distro               : f12-x86_64                                                                                           
architecture         : x86_64                                                                                               
breed                : redhat                                                                                               
created              : Thu Dec 17 00:22:49 2009                                                                             
comment              :                                                                                                      
initrd               : /var/www/cobbler/ks_mirror/f12-x86_64/images/pxeboot/initrd.img                                      
kernel               : /var/www/cobbler/ks_mirror/f12-x86_64/images/pxeboot/vmlinuz                                         
kernel options       : {}                                                                                                   
ks metadata          : {}
tree build time      : Wed Dec 31 19:00:00 1969
modified             : Thu Dec 17 00:22:49 2009
mgmt classes         : []
os version           :
owners               : ['admin']
post kernel options  : {}
redhat mgmt key      : <<inherit>>
redhat mgmt server   : <<inherit>>
template files       : {}

Not sure if it is related or not, but there isn't a link in /var/www/cobbler/links/ that should point to this distro. I've lost the exact command I used to import from my history, but I'm 99% sure it was simply "sudo cobbler import --name=f12 --arch=x86_64 --path=rsync://path/to/rsync/mirror". I immediately tried to boot the rescue-f12-x86_64 profile after the import was done, which is when I discovered the problem.
Comment 4 Devan Goodwin 2010-01-07 07:57:33 EST
Hi Trevor, I tried an import exactly as you specified and cannot reproduce the issue, the distro gets it's kickstart metadata as expected. Can you try to reproduce and see if you can isolate how it's happening?
Comment 5 Trever Fischer 2010-01-17 13:44:11 EST
I reproduced it and it seems that 'fedora12' was simply missing from /usr/lib/python2.6/site-packages/cobbler/codes.py

Adding it fixes everything. However this isn't in the latest cobbler available.
Comment 6 Devan Goodwin 2010-01-18 08:28:48 EST
Ah yes that has popped up a few times on the list. Will be fixed in next release. Cheers.

Note You need to log in before you can comment on or make changes to this bug.